<template>
  <div class="feature-section bg-color-white">
    <h2 class="fr-h4">Informations administrateur</h2>
    <div class="fr-table fr-table--bordered">
      <table>
        <thead>
          <tr>
            <th scope="col">{{ userFieldLabels.lastName }}</th>
            <th scope="col">{{ userFieldLabels.firstName }}</th>
            <th scope="col">{{ userFieldLabels.email }}</th>
            <th
              id="role-col"
              scope="col"
            >
              {{ userFieldLabels.role }}
            </th>
            <th
              id="authorisation-col"
              scope="col"
            >
              {{ userFieldLabels.aidantConnectAuthorisation }}
            </th>
            <th
              id="status-col"
              scope="col"
            >
              {{ userFieldLabels.status }}
            </th>
          </tr>
        </thead>
        <tbody>
          <NuxtLink
            v-for="user in users"
            :key="user.id"
            v-slot="{ navigate }"
            custom
            :to="routes.admin.AdminUser.path(user.id)"
          >
            <tr
              class="clickable-row"
              @click="navigate"
            >
              <td>{{ user.lastName }}</td>
              <td>{{ user.firstName }}</td>
              <td>{{ user.email }}</td>
              <td>
                {{ nonAdminUserRoleKeys.value(user.role as NonAdminUserRole) }}
              </td>
              <td>
                <span
                  v-if="!!user.aidantConnectAuthorisation"
                  class="fr-icon-checkbox-line"
                  aria-hidden="true"
                ></span>
                <span
                  v-else
                  class="fr-icon-close-circle-line"
                  aria-hidden="true"
                ></span>
              </td>
              <td>
                <span
                  v-if="user.status === UserStatus.Active"
                  class="fr-icon-checkbox-line"
                  aria-hidden="true"
                ></span>
                <span
                  v-else
                  class="fr-icon-close-circle-line"
                  aria-hidden="true"
                ></span>
              </td></tr
          ></NuxtLink>
        </tbody>
      </table>
    </div>
    <NuxtLink
      :to="{
        path: routes.admin.AdminUsersAdd.path(),
        query: { structureId }
      }"
      class="fr-btn fr-mt-2w fr-btn--icon-left fr-icon-user-add-line"
    >
      Ajouter un utilisateur
    </NuxtLink>
  </div>
</template>

<script lang="ts" setup>
  import { UserStatus } from '@prisma/client'
  import type { StructureUsers } from './types'
  import { userFieldLabels } from '~/client/labels'
  import { nonAdminUserRoleKeys } from '~/client/options'
  import { routes } from '~/utils/routes'
  import type { NonAdminUserRole } from '~/types/user'

  defineProps<{
    structureId: string
    users: StructureUsers
  }>()
</script>
